<template>
  <v-expansion-panel-title>
    <template v-slot:default="{ expanded }">
      <v-row no-gutters>
        <v-col class="d-flex align-center">
          <v-icon
            class="mr-3"
            :icon="action.icon"
          />
          <p>{{ action.name }}</p>
        </v-col>
        <v-col class="d-flex justify-end mr-6">
          <v-btn-toggle
            density="compact"
            mandatory
            v-model="action.enabled"
          >
            <v-btn
              class="pa-0"
              elevation="0"
              flat="true"
              :value="true"
              @click.native.stop="update"
            >ON
            </v-btn>
            <v-btn
              class="pa-0"
              elevation="0"
              flat="true"
              :value="false"
              @click.native.stop="update"
            >OFF
            </v-btn>
          </v-btn-toggle>
        </v-col>
      </v-row>
    </template>
  </v-expansion-panel-title>
  <v-expansion-panel-text>
    <v-row
      v-for="field in action.config_fields"
      :key="field.name"
      no-gutters
      class="my-1"
    >
      <v-col v-if="field.type === 'text'">
        <v-text-field
          variant="solo"
          bg-color="grey-darken-3"
          density="compact"
          hide-details
          v-model="action[field.name]"
          :label="field.label"
          @change="update"
        />
      </v-col>
      <v-col v-else-if="field.type === 'textarea'">
        <v-textarea
          variant="solo"
          bg-color="grey-darken-3"
          density="compact"
          hide-details
          v-model="action[field.name]"
          :label="field.label"
          @change="update"
          no-resize
        />
      </v-col>
      <v-col
        v-else-if="field.type === 'model'"
        class="d-flex justify-space-between"
      >
        <v-btn-toggle
          density="compact"
          mandatory
          v-model="action[field.name]"
        >
          <v-btn
            v-for="model in models"
            :key="model.name"
            :value="model.value"
            @click.native.stop="update"
          >{{ model.name }}
          </v-btn>
        </v-btn-toggle>
      </v-col>
    </v-row>
    <!--    <v-row-->
    <!--      no-gutters-->
    <!--      class="my-1"-->
    <!--    >-->
    <!--      <v-col>-->
    <!--        <v-text-field-->
    <!--          variant="solo"-->
    <!--          bg-color="grey-darken-3"-->
    <!--          density="compact"-->
    <!--          hide-details-->
    <!--          v-model="action.name"-->
    <!--          label="Name"-->
    <!--          @change="update"-->
    <!--        />-->
    <!--      </v-col>-->
    <!--    </v-row>-->
    <!--    <v-row-->
    <!--      no-gutters-->
    <!--      class="my-1"-->
    <!--    >-->
    <!--      <v-col>-->
    <!--        <v-text-field-->
    <!--          variant="solo"-->
    <!--          bg-color="grey-darken-3"-->
    <!--          density="compact"-->
    <!--          hide-details-->
    <!--          v-model="action.icon"-->
    <!--          label="Icon"-->
    <!--          @change="update"-->
    <!--        />-->
    <!--      </v-col>-->
    <!--    </v-row>-->
    <!--    <v-row-->
    <!--      no-gutters-->
    <!--      class="my-1"-->
    <!--    >-->
    <!--      <v-col>-->
    <!--        <v-text-field-->
    <!--          variant="solo"-->
    <!--          bg-color="grey-darken-3"-->
    <!--          density="compact"-->
    <!--          hide-details-->
    <!--          v-model="action.shortcut"-->
    <!--          label="Shortcut"-->
    <!--          @change="update"-->
    <!--        />-->
    <!--      </v-col>-->
    <!--    </v-row>-->
    <!--    <v-row-->
    <!--      no-gutters-->
    <!--      class="my-1"-->
    <!--    >-->
    <!--      <v-col>-->
    <!--        <v-textarea-->
    <!--          v-if="action.has_system_prompt || action.is_created"-->
    <!--          variant="solo"-->
    <!--          bg-color="grey-darken-3"-->
    <!--          density="compact"-->
    <!--          hide-details-->
    <!--          v-model="action.system_prompt"-->
    <!--          label="System prompt"-->
    <!--          @change="update"-->
    <!--          no-resize-->
    <!--        />-->
    <!--      </v-col>-->
    <!--    </v-row>-->
        <v-row
          no-gutters
          class="my-1"
        >
          <v-col class="d-flex justify-space-between">
            <v-btn
              v-if="action.is_created"
              variant="tonal"
              color="green"
              @click="create"
            >Create</v-btn>
            <v-btn
              v-if="!action.is_created && action.custom"
              variant="tonal"
              color="red"
              @click="deleteAction"
            >Delete</v-btn>
          </v-col>
        </v-row>
  </v-expansion-panel-text>
</template>

<script>
import MyAPI from "../../apis/MyAPI.js";
import store from "/src/store/store.js";

export default {
  name: "SnippetSetting",
  props: {
    action: Object
  },
  computed: {
    models() {
      return store.getters.getModels;
    }
  },
  methods: {
    async update() {
      if (!this.action.is_created) {
        await MyAPI.updateAction(this.action);
      }
    },
    async create() {
      this.action.enabled = true;
      await MyAPI.createAction(this.action);
      this.action.is_created = false;
    },
    deleteAction() {
      store.dispatch('deleteAction', this.action);
    }
  },
}
</script>